<!doctype html>
<html>
	<head>
		<meta charset="utf-8">
		<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">

		<title>Bitwise Operators</title>

		<link rel="icon" type="image/png" href="images/org_symbol.png" />
		<link rel="stylesheet" href="css/reset.css">
		<link rel="stylesheet" href="css/reveal.css">
		<link rel="stylesheet" href="css/theme/league.css" id="theme">

		<!-- Theme used for syntax highlighting of code -->
		<link rel="stylesheet" href="lib/css/monokai.css">

		<!-- Printing and PDF exports -->
		<script>
			var link = document.createElement( 'link' );
			link.rel = 'stylesheet';
			link.type = 'text/css';
			link.href = window.location.search.match( /print-pdf/gi ) ? 'css/print/pdf.css' : 'css/print/paper.css';
			document.getElementsByTagName( 'head' )[0].appendChild( link );
		</script>
	</head>
	<body>
		<div style="background:green; left:0; right:0; position:absolute; height:30px;">
			<div style="text-align: center;">(U)Unclassified</div>
		</div>

        <div class="reveal">
            <div class="slides">
                <!-- Introduction Section -->
                <section data-background-image="images/org_symbol.png" data-background-size="13%" data-background-position="top 5% left 5%">
                    <section>
                        <h1>Bitwise Operators</h1>    
                    </section>
                    <section>
                        <h2>Bitwise Operators Overview</h2>
                        <ul>
                            <li>Bitwise Operations</li>
                            <li>Numbering Systems</li>
                            <li>Bitwise Operators</li>
                        </ul>
                    </section>
                    <section>
                        <h2><a href=../objectives.html>Objectives</a></h2>
                    </section>
                </section>
                <!-- Bitwise Operations Section -->
                <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 5%">   
                    <section>
                        <h2>Bitwise Operations</h2>

                        <aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
                    </section>

                    <section>
                        <h2>Bits</h2>
                        <ul>
                            <li>The smallest unit in a computer, either a 0 or a 1</li>
                            <li>1 - On/True</li>
                            <li>0 - Off/False</li>
                        </ul>
                    </section>

                    <section>
                        <h3>In simple terms, bitwise operations test or modify bits</h3>
                    </section>

                    <section>
                        <h2>Where is Bitwise Used?</h2>
                        <ul>
                            <li>Device Drivers</li>
                            <li>Pixel-Level Graphics</li>
                            <li>Assembly</li>
                            <li>Encryption</li>
                            <li>Manipulation</li>
                        </ul>
                    </section>

                    <section>
                        <h3>Note: Bitwise operations is also faster than manipulation</h3>
                    </section>
                </section>
                <!-- Numbering Systems Section -->
                <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 5%">
                    <section>
                        <h2>Numbering Systems</h2>

                        <aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
                    </section>
                    <section>
                        <h2>Review of Numbering Systems</h2>
                        <img src="../../assets/numsReview.png">
                    </section>

                    <section>
                        <h2>Converting Hex, Octal and Binary to Decimal</h2>
                    </section>

                    <section>
                        <h2>Complete Reviews on the MDBook</h2>
                    </section>
                </section>
                <!-- Bitwise Operators Section -->
                <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 5%">
                    <section>
                        <h2>Bitwise Operators</h2>

                        <aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
                    </section>
                    <section>
                        <h2>Bitwise Operators Are:</h2>
                        <ul>
                            <li>performed on the entire binary representation of the value</li>
                            <li>performed on all bits separately</li>
                        </ul>
                    </section>

                    <section>
                        <div class="sl-block" data-block-type="code" data-name="code-081686"><div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none" style="z-index: 10;"><pre style="font-size: 16px; line-height: 19px;"><code data-line-numbers="">
// Bitwise AND
x & y         // 1 if 1 in both x and y

// Bitwise OR
x | y         // 1 if 1 in either x or y, or both

// Bitwise XOR
x ^ y         // 1, if 1 in either x or y, but not both

// Bitwise NOT
~x            // 1, if 0 in x

// Shift Left
x << y        // Each bit in x is shifted y positions left

// Shift Right
x >> y        // Each bit in x is shifted y positions right
</code></pre></div></div>
                    </section>

                    <section>
                        <h2>Bitwise AND</h2>
                        <img src="../../assets/bin12.PNG">
                    </section>

                    <section>
                        <h2>Bitwise AND</h2>
                        <img src="../../assets/bin13.PNG">
                    </section>

                    <section>
                        <h2>Bitwise OR</h2>
                        <img src="../../assets/bin14.PNG">
                    </section>

                    <section>
                        <h2>Bitwise OR</h2>
                        <img src="../../assets/bin15.PNG">
                    </section>

                    <section>
                        <h2>Bitwise OR cont.</h2>
                        <p>Bitwise OR can be used to turn on some bits</p>
                        <div class="sl-block" data-block-type="code" data-name="code-081686"><div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none" style="z-index: 10;"><pre style="font-size: 16px; line-height: 19px;"><code data-line-numbers="">
// BITWISE OR
uint16_t = bwResult = 0;                // 0000 0000 0000 0000
uint16_t num1 = 12;                     // 0000 0000 0000 1100
uint16_t num2 = 3;                      // 0000 0000 0000 0011
bwResult = num1 | num2;                 // 0000 0000 0000 1111

uint16_t num3 = 240;                    // 0000 0000 1111 0000
bwResult = bwResult | num3;             // 0000 0000 1111 1111

uint16_t num4 = 768;                    // 0000 0011 0000 0000
bwResult = bwResult | num4;             // 0000 0011 1111 1111

uint16_t turnOn = 65280;                // 1111 1111 0000 0000
bwResult = bwResult | turnOn;           // 1111 1111 1111 1111
</code></pre></div></div>
                    </section>

                    <section>
                        <h2>Bitwise XOR</h2>
                        <img src="../../assets/bin16.PNG">
                    </section>

                    <section>
                        <h2>Bitwise XOR</h2>
                        <img src="../../assets/bin17.PNG">
                    </section>

                    <section>
                        <h2>Bitwise XOR cont.</h2>
                        <p>Swapping values without a temp variable</p>
                        <div class="sl-block" data-block-type="code" data-name="code-081686"><div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none" style="z-index: 10;"><pre style="font-size: 16px; line-height: 19px;"><code data-line-numbers="">
/* SWAP TWO VARIABLES WITH XOR (^) WITHOUT USING A TEMP VARIABLE */
// SAMPLE EXECUTION OF BITWISE XOR SWAP
uint8_t x = 1;                  // 0000 0001
uint8_t y = 254;                // 1111 1110
x = x ^ y;                      // x = 1111 1111 == (x)0000 0001 ^ (y)1111 1110
y = x ^ y;                      // y = 0000 0001 == (x)1111 1111 ^ (y)1111 1110
x = x ^ y;                      // x = 1111 1110 == 1111 1111 ^ 0000 0001

// SAMPLE EXECUTION OF BITWISE XOR SWAP
uint8_t p = 42;                 // 0010 1010
uint8_t q = 11;                 // 0000 1011
p = p ^ q;                      // p = 0010 0001 = (p)0010 1010 ^ (q)0000 1011
q = p ^ q;                      // q = 0010 1010 = (p)0010 0001 ^ (q)0000 1011
p = p ^ q;                      // p = 0000 1011 = (p)0010 0001 ^ (q)0010 1010
</code></pre></div></div>
                    </section>

                    <section>
                        <h2>Bitwise NOT</h2>
                        <img src="../../assets/bin18.PNG">
                    </section>

                    <section>
                        <h2>Bitwise NOT</h2>
                        <img src="../../assets/bin19.PNG">
                    </section>

                    <section>
                        <h2>Left Shift</h2>
                        <img src="../../assets/bin20.PNG">
                    </section>

                    <section>
                        <h2>Left Shift</h2>
                        <img src="../../assets/bin21.PNG">
                    </section>

                    <section>
                        <h2>Right Shift</h2>
                        <img src="../../assets/bin22.PNG">
                    </section>

                </section>

                <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 5%">
                    <h2>Performance Labs</h2>
                </section>

                <!-- Conclusion Section -->
                <section data-background-image="images/org_symbol.png" data-background-size="13%" data-background-position="top 5% left 5%">
                    <section>
                        <h2>Questions?</h2>
                    </section>
                    <section data-background-image="images/org_symbol.png" data-background-size="13%" data-background-position="top 5% left 5%">
                        <h2>Summary</h2>
                        <ul>
                            <li>Bitwise Operations</li>
                            <li>Numbering Systems</li>
                            <li>Bitwise Operators</li>
                        </ul>
                    </section>
                </section>
            </div>
        </div>

        <footer style="background:green; left:0; right:0; bottom: 0; position:absolute; height:30px;">
			<div style="text-align: center;">(U)Unclassified</div>
		</footer>	
			
			
		<script src="js/reveal.js"></script>

		<script>
			// More info about config & dependencies:
			// - https://github.com/hakimel/reveal.js#configuration
			// - https://github.com/hakimel/reveal.js#dependencies
			Reveal.initialize({
				hash: true,
				menu: {
					// Specifies which side of the presentation the menu will 
					// be shown. Use 'left' or 'right'.
					side: 'left',

					// Specifies the width of the menu.
					// Can be one of the following:
					// 'normal', 'wide', 'third', 'half', 'full', or
					// any valid css length value
					width: 'normal',

					// Add slide numbers to the titles in the slide list.
					// Use 'true' or format string (same as reveal.js slide numbers)
					numbers: true,

					// Specifies which slide elements will be used for generating
					// the slide titles in the menu. The default selects the first
					// heading element found in the slide, but you can specify any
					// valid css selector and the text from the first matching
					// element will be used.
					// Note: that a section data-menu-title attribute or an element
					// with a menu-title class will take precedence over this option
					titleSelector: 'h1, h2, h3, h4, h5, h6',

        // If slides do not have a matching title, attempt to use the
        // start of the text content as the title instead
        useTextContentForMissingTitles: false,

        // Hide slides from the menu that do not have a title.
        // Set to 'true' to only list slides with titles.
        hideMissingTitles: false,

        // Adds markers to the slide titles to indicate the 
        // progress through the presentation. Set to 'false'
        // to hide the markers.
        markers: true,

        // Specify custom panels to be included in the menu, by
        // providing an array of objects with 'title', 'icon'
        // properties, and either a 'src' or 'content' property.
        custom: false,

        // Specifies the themes that will be available in the themes
        // menu panel. Set to 'true' to show the themes menu panel
        // with the default themes list. Alternatively, provide an
        // array to specify the themes to make available in the
        // themes menu panel, for example...
        // [
        //     { name: 'Black', theme: 'css/theme/black.css' },
        //     { name: 'White', theme: 'css/theme/white.css' },
        //     { name: 'League', theme: 'css/theme/league.css' }
        // ]
        themes: true,

        // Specifies the path to the default theme files. If your
        // presentation uses a different path to the standard reveal
        // layout then you need to provide this option, but only
        // when 'themes' is set to 'true'. If you provide your own 
        // list of themes or 'themes' is set to 'false' the 
        // 'themesPath' option is ignored.
        themesPath: 'css/theme/',

        // Specifies if the transitions menu panel will be shown.
        // Set to 'true' to show the transitions menu panel with
        // the default transitions list. Alternatively, provide an
        // array to specify the transitions to make available in
        // the transitions panel, for example...
        // ['None', 'Fade', 'Slide']
        transitions: true,

        // Adds a menu button to the slides to open the menu panel.
        // Set to 'false' to hide the button.
        openButton: true,

        // If 'true' allows the slide number in the presentation to
        // open the menu panel. The reveal.js slideNumber option must 
        // be displayed for this to take effect
        openSlideNumber: true,

        // If true allows the user to open and navigate the menu using
        // the keyboard. Standard keyboard interaction with reveal
        // will be disabled while the menu is open.
        keyboard: true,

        // Normally the menu will close on user actions such as
        // selecting a menu item, or clicking the presentation area.
        // If 'true', the sticky option will leave the menu open
        // until it is explicitly closed, that is, using the close
        // button or pressing the ESC or m key (when the keyboard 
        // interaction option is enabled).
        sticky: true,

        // If 'true' standard menu items will be automatically opened
        // when navigating using the keyboard. Note: this only takes 
        // effect when both the 'keyboard' and 'sticky' options are enabled.
        autoOpen: true,

        // If 'true' the menu will not be created until it is explicitly
        // requested by calling RevealMenu.init(). Note this will delay
        // the creation of all menu panels, including custom panels, and
        // the menu button.
        delayInit: false,

        // If 'true' the menu will be shown when the menu is initialised.
        openOnInit: false,

        // By default the menu will load it's own font-awesome library
        // icons. If your presentation needs to load a different
        // font-awesome library the 'loadIcons' option can be set to false
        // and the menu will not attempt to load the font-awesome library.
        loadIcons: true
    },
    dependencies: [
        { src: 'plugin/markdown/marked.js' },
        { src: 'plugin/markdown/markdown.js' },
        { src: 'plugin/highlight/highlight.js' },
        { src: 'plugin/notes/notes.js', async: true },
        { src: 'plugin/reveal.js-menu/menu.js' }
    ]
});
</script>
</body>
</html>
